books/urls.py
from django.conf.urls import url, include

from . import views

urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^(?P<book_id>[0-9]+)/$', views.detail, name='detail'),
    url(r'^(?P<book_id>[0-9]+)/order/$', views.order, name='order'),
    url(r'^order/$', views.order_page, name='order_page'),
    url(r'^wait/$', views.test_cache, name='test_cache'),
]

books_catalogue/urls.py
from django.conf.urls import include, url
from django.contrib import admin
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    url(r'^books/', include('books.urls', namespace="books")),
    url(r'^admin/', include(admin.site.urls)),
    url(r'^api-books/', include('books.api_urls', namespace="books_api")),
    url(r'^api-auth/', include('rest_framework.urls', namespace='rest_framework')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

books/models.py
from django.utils import timezone
from django.db import models
from .validators import validate_file_extension

class Book(models.Model):
	author = models.CharField(max_length=40)
	year_publishing = models.IntegerField()
	# 1 - Study, 2 - Techniq, 3 - Detective; hardcoded now
	themes = models.IntegerField(default=1)
	title = models.CharField(max_length=40)
	cover = models.ImageField(upload_to='images', validators=[validate_file_extension])
	# 0 - books, 1 - magazine
	category = models.IntegerField(default=0)
	desc = models.CharField(max_length=200)
	price = models.FloatField()

	def __str__(self):
		return self.title


class Order(models.Model):
	pub_date = models.DateTimeField('date published', default=timezone.now())
	user_cookie = models.CharField(max_length=100)
	customer = models.CharField(max_length=40)
	delivery_address = models.CharField(max_length=60)
	# new, pending, delivered, canceled, return
	status = models.IntegerField(default=0)

	def __str__(self):
		return self.user_cookie

	def books_count(self):
		books_orders=BooksOrder.objects.filter(order_id=self.id).all()
		res = 0
		for bo in books_orders:
			res += bo.count
		return res

	def books(self):
		books_orders=BooksOrder.objects.filter(order_id=self.id).all()
		res = []
		for bo in books_orders:
			res.append({'book': bo.book, 'count': bo.count})
		return res


class BooksOrder(models.Model):
	book = models.ForeignKey(Book)
	order = models.ForeignKey(Order)
	count = models.IntegerField(default=1)

	def __str__(self):
		return 'Book {}; Order: {}; Count: {}'.format(self.book, self.order, self.count)

books/forms.py
from django.forms import CharField, ModelForm
from .models import Order

class OrderForm(ModelForm):

	class Meta:
		model = Order
		fields = ('customer', 'delivery_address')
	    # customer = forms.CharField(max_length=40, required=True)
	    # delivery_address = forms.CharField(max_length=60, required=True)

books/views.py
import time
from django.http import HttpResponse, Http404, HttpResponseRedirect, JsonResponse
from django.utils import timezone
from django.db.models import Q
# from django.template import loader
from django.shortcuts import render, get_object_or_404
from django.core.urlresolvers import reverse
from rest_framework import viewsets
import uuid

from django.contrib.auth.models import User, Group
from .models import Book, Order, BooksOrder
from .forms import OrderForm
from .serializers import UserSerializer, GroupSerializer, BookSerializer

def get_order_count(request):
    if 'order' in request.session:
        order = get_object_or_404(Order, user_cookie=request.session['order'])
        order_count = order.books_count()
    else:
        order_count = 0
    return order_count

def index(request):
    if request.method == 'GET':
        books = Book.objects.order_by('-pk')
        context = {
            'books': books,
            'order_count': get_order_count(request)
        }
        print('context', context)
        return render(request, 'books/index.html', context)
    elif request.method == 'POST':
        kargs = []
        kwargs = {}
        if 'category_book' not in request.POST and 'category_magazine' not in request.POST:
            return render(request, 'books/index.html', {'books': None})
        elif 'category_book' not in request.POST and 'category_magazine' in request.POST:
            kwargs['category'] = 1
        elif 'category_book' in request.POST and 'category_magazine' not in request.POST:
            kwargs['category'] = 0
        kwargs['year_publishing__gte'] = request.POST['year_from']
        kwargs['year_publishing__lte'] = request.POST['year_to']
        if int(request.POST['themes']) > 0:
            kwargs['themes'] = request.POST['themes']
        kargs.append(Q(title__icontains=request.POST['title']))
        kargs.append(Q(author__icontains=request.POST['author']))
        books = Book.objects.filter(*kargs, **kwargs)
        print(books)
        return render(request, 'books/index.html', {'books': books, 'order_count': get_order_count(request)})

def detail(request, book_id):
    book = get_object_or_404(Book, pk=book_id)
    return render(request, 'books/detail.html', {'book': book, 'order_count': get_order_count(request)})

def order(request, book_id):
    book = get_object_or_404(Book, id=book_id)
    print(book)
    # get or create order
    user_cookie = request.session.get('order', False)
    if not user_cookie:
        print('not order')
        user_cookie = request.session['order'] = str(uuid.uuid4())
    print('user_cookie', request.session['order'])
    order = Order.objects.filter(user_cookie=user_cookie).first()
    if not order:
        order = Order(pub_date=timezone.now(), user_cookie=request.session['order'], status=0)
        order.save()
    print(order)
    print(order.id)
    # get or update BooksOrder
    books_order = BooksOrder.objects.filter(book=book, order=order).first()
    if not books_order:
        print('new book_order')
        books_order = BooksOrder.objects.create(book_id=book.id, order_id=order.id, count=1)
        books_order.save()
    else:
        print('update book_order')
        books_order.count += 1
        books_order.save()
    print(books_order)
    return JsonResponse({'status': 'success', 'order_count': order.books_count()})


def order_page(request):
    order = get_object_or_404(Order, user_cookie=request.session['order'])
    print(order)
    print(order.customer)
    books = order.books()
    if request.method == 'POST':
        formset = OrderForm(request.POST, instance=order)
        if formset.is_valid():
            formset.save()
            # do something.
            return render(request, 'books/index.html')
    else:
        formset = OrderForm()
    return render(request, 'books/order.html', {'order': order, 'books': books, 'formset': formset, 'order_count': get_order_count(request)})


def test_cache(request):
    time.sleep(3)
    return render(request, 'books/bum.html')


# API
class UserViewSet(viewsets.ModelViewSet):
    """
    API endpoint that allows users to be viewed or edited.
    """
    queryset = User.objects.all().order_by('-date_joined')
    serializer_class = UserSerializer


class GroupViewSet(viewsets.ModelViewSet):
    """
    API endpoint that allows groups to be viewed or edited.
    """
    queryset = Group.objects.all()
    serializer_class = GroupSerializer


class BookViewSet(viewsets.ModelViewSet):
    """
    API endpoint that allows books to be viewed or edited.
    """
    queryset = Book.objects.all()
    serializer_class = BookSerializer

books/templates/books/bum.html
{% load staticfiles %}
<script src="{% static 'books/js/jquery-3.1.1.min.js' %}"</script>
<script type="text/javascript"></script>

<script type="text/javascript">
	console.log(111111);
	$.get('/api-books/books', (res)=>{
		console.log(res);
	})
</script>

<div class="container">
	<h1>Bum!</h1>
</div>

books/templates/books/detail.html
{% load staticfiles %}
<link rel="stylesheet" href="{% static 'books/css/bootstrap.min.css' %}">
<link rel="stylesheet" href="{% static 'books/css/bootstrap-theme.min.css' %}">
<link href="{% static 'books/css/style.css' %}" rel="stylesheet" media="screen">
<script src="{% static 'books/js/jquery-3.1.1.min.js' %}"</script>
<script type="text/javascript">
	function addBookToOrder(book_id) {
		console.log('new book '+book_id);
		$.get('/books/'+book_id+'/order/', (res)=>{
			console.log(res);
			if (res.status == 'success')
				$('#order_count')[0].innerHTML = res.order_count;
			else
				alert('Error');
		})
	}
</script>

<nav class="navbar navbar-default ">
  <div class="container-fluid">
    <div class="navbar-header">
      <a class="navbar-brand" href="{% url 'books:index' %}">Books</a>
    </div>
    
	<div class="collapse navbar-collapse custom-shopping-cart">
 		<a class="glyphicon glyphicon-shopping-cart" href="{% url 'books:order_page' %}"></a>
 		<span id="order_count" class="custom-shopping-cart-count">{{ order_count }}</span>
	</div>
  </div>
</nav>

<div class="container">
	<div class="row">
		<div class="col-md-3 books-item-detail">
			<div class="books-title-detail">
				<h2>Detail info</h2>
			</div>
	    	<img class="img-responsive" src="{{ book.cover.url }}" alt="" onmouseover="$('.books-item-detail-zoom').css('display', 'inherit')"
	    		 onmouseleave="$('.books-item-detail-zoom').css('display', 'none')">
			<h4 class="books-title-detail">{{ book.title }}</h4>
	    	<p class="books-attributes">Author: {{ book.author }}</p>
	    	<p class="books-attributes">Year: {{ book.year_publishing }}</p>
	    	<p class="books-attributes">Themes: {{ book.themes }}</p>
			<p class="books-attributes">Price: {{ book.price }}$</p>
			<br>
			<p class="books-attributes">Description: {{ book.desc }}...</p>
			<input type="button" class="btn btn-success" value="Add to order" onclick="addBookToOrder({{ book.id }})"></input>
		</div>
		<div class="col-md-4 books-item-detail-zoom">
	    	<img class="img-responsive" src="{{ book.cover.url }}" alt="">
		</div>
	</div>
</div>

books/templates/books/index.html
{% load staticfiles %}
<!-- Latest compiled and minified CSS -->
<link rel="stylesheet" href="{% static 'books/css/bootstrap.min.css' %}">
<link rel="stylesheet" href="{% static 'books/css/bootstrap-theme.min.css' %}">
<link href="{% static 'books/css/style.css' %}" rel="stylesheet" media="screen">
<script src="{% static 'books/js/jquery-3.1.1.min.js' %}"</script>
<script type="text/javascript"></script>

<nav class="navbar navbar-default ">
  <div class="container-fluid">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="navbar-header">
      <a class="navbar-brand" href="{% url 'books:index' %}">Books</a>
    </div>

	<div class="collapse navbar-collapse custom-shopping-cart">
 		<a class="glyphicon glyphicon-shopping-cart" href="{% url 'books:order_page' %}"></a>
 		<span id="order_count" class="custom-shopping-cart-count">{{ order_count }}</span>
	</div>
  </div><!-- /.container-fluid -->
</nav>


{% if books %}
	<div class="container">

		<div class="row">
			<div class="col-md-2">
				<h2>Search</h2>
				<form action="{% url 'books:index' %}" method="post">
					{% csrf_token %}
					<div class="row form-group">
						<input class="form-control" type="text" name="title" placeholder="Title">
						<input class="form-control" type="text" name="author" placeholder="Author">
						<label>Publish year:</label>
						<div class="row margin-bottom-0">
							<div class="col-md-4 padding-right-0 text-center">
								<label>From</label>
							</div>
							<div class="col-md-8 padding-left-0">
								<select class="form-control margin-bottom-0" name="year_from" id="select_year_from"></select>
							</div>
							<div class="col-md-4 padding-right-0 text-center">
								<label>To</label>
							</div>
							<div class="col-md-8 padding-left-0">
								<select class="form-control margin-bottom-0" name="year_to" id="select_year_to"></select>
							</div>
						</div>
						<label>Categories:</label>
						<select class="form-control" name="themes" id="select_themes"></select>
						<div class="checkbox">
							<label><input type="checkbox" name="category_book" checked>Books</label>
						</div>
						<div class="checkbox">
							<label><input type="checkbox" name="category_magazine" checked>Magazines</label>
						</div>
						<div class="text-center">
							<input class="btn btn-success" type="submit" value="Search" name="">
						</div>
					</div>
				</form>
			</div>
			<div class="col-md-10 padding-left-35">
				<div class="row">
					<h2 class="catalogue-title">Catalogue</h2>
				    <div class="books-gallery">
					    {% for book in books %}
					    	<div class="books-item">
						        <a href="{% url 'books:detail' book.id %}">
						        	<img src="{{ book.cover.url }}">
						    		<h4 class="books-title">{{ book.title }}</h4>
						    	</a>
						    	<p class="books-attributes">Author: {{ book.author }}</p>
						    	<p class="books-attributes">Year: {{ book.year_publishing }}</p>
						    	<p class="books-attributes">Themes: {{ book.themes }}</p>
						    	<p class="books-attributes">Price: {{ book.price }}$</p>
								{% csrf_token %}
						    	<input type="button" class="btn btn-success" value="Add to order" onclick="addBookToOrder({{ book.id }})"></input>
					    	</div>
					    {% endfor %}
					</div>
				</div>
			</div>
		</div>
	</div>
	<script type="text/javascript">
		document.addEventListener("DOMContentLoaded", ready);
		function ready(argument) {
			generateYearsOptions('select_year_from');
			generateYearsOptions('select_year_to', true);
			generateThemes();
		}
		function generateYearsOptions(selectID, date_to=false){
			var min = 1900,
		    	max = 2016,
				select = document.getElementById(selectID);
			for (var i = min; i<=max; i++){
			    var opt = document.createElement('option');
			    opt.value = i;
			    opt.innerHTML = i;
			    select.appendChild(opt);
			}
			if (date_to){
				select.value = 2016
			}
		}
		function generateThemes(){
			var themes = ['', 'Study', 'Techniq', 'Detective'],
				select = document.getElementById('select_themes');
			for (var i = 0; i<themes.length; i++){
			    var opt = document.createElement('option');
			    opt.value = i;
			    opt.innerHTML = themes[i];
			    select.appendChild(opt);
			}
		}
		function addBookToOrder(book_id) {
			console.log('new book '+book_id);
			$.get('/books/'+book_id+'/order/', (res)=>{
				console.log(res);
				if (res.status == 'success')
					$('#order_count')[0].innerHTML = res.order_count;
				else
					alert('Error');
			})
		}
	</script>
{% else %}
	<p><strong>No books found</strong></p>
{% endif %}

books/templates/books/order.html
{% load staticfiles %}
<link rel="stylesheet" href="{% static 'books/css/bootstrap.min.css' %}">
<link rel="stylesheet" href="{% static 'books/css/bootstrap-theme.min.css' %}">
<link href="{% static 'books/css/style.css' %}" rel="stylesheet" media="screen">
<script src="{% static 'books/js/jquery-3.1.1.min.js' %}"</script>
<script type="text/javascript"></script>

<nav class="navbar navbar-default ">
  <div class="container-fluid">
    <div class="navbar-header">
      <a class="navbar-brand" href="{% url 'books:index' %}">Books</a>
    </div>
    
	<div class="collapse navbar-collapse custom-shopping-cart">
 		<a class="glyphicon glyphicon-shopping-cart" href="{% url 'books:order_page' %}"></a>
 		<span id="order_count" class="custom-shopping-cart-count">{{ order_count }}</span>
	</div>
  </div>
</nav>

<div class="container">
	<div class="row">
		<div class="books-title">
			<h2>Shop order</h2>
		</div>
		<h4 class="books-title">Order #: {{ order.id }}</h4>
		<div class="books-gallery">
			{% for book in books %}
				<div class="books-item">
			        <a href="{% url 'books:detail' book.book.id %}">
			        	<img src="{{ book.book.cover.url }}">
			    		<h4 class="books-title">{{ book.book.title }}</h4>
			    	</a>
					<div class="">Price: {{ book.book.price }}$</div>
					<div class="">Count: {{ book.count }}</div>
				</div>
			{% endfor %}
		</div>
		<form method="post" action="">
			{% csrf_token %}
			{{ formset.as_p }}
		    <button type="submit">Submit</button>
		</form>
	</div>
</div>